"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Modal = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = require("react");
const portal_1 = require("./portal");
const Modal = ({ visible = true, onRequestClose, children }) => {
    const [prevVisible, setPrevVisible] = (0, react_1.useState)(visible);
    (0, react_1.useEffect)(() => {
        if (prevVisible && !visible) {
            onRequestClose === null || onRequestClose === void 0 ? void 0 : onRequestClose();
        }
        setPrevVisible(visible);
    }, [visible]);
    return ((0, jsx_runtime_1.jsx)(portal_1.ModalPortal, { children: visible ? children : null }));
};
exports.Modal = Modal;
//# sourceMappingURL=modal.js.map