import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import Image from 'next/image';
import { useEffect, useState } from 'react';
export function ImageSlide(props) {
    const { images, containerWidth = '100%', 
    // imageWidth,
    startIndex = 0, isLoop = false, } = props;
    const [index, setIndex] = useState(startIndex);
    const [calcWidth, setCalcWidth] = useState();
    const [isDragging, setIsDragging] = useState(false);
    const [mouseStartX, setMouseStartX] = useState(0);
    const [calculatedX, setCalculatedX] = useState(0);
    useEffect(() => {
        const windowWidth = typeof window !== 'undefined' && window.innerWidth;
        const cal = windowWidth * 0.8;
        setCalcWidth(cal);
    }, []);
    const moveRight = () => {
        if (index !== images.length - 1) {
            setIndex((prev) => prev + 1);
        }
        else {
            if (isLoop) {
                setIndex(0);
            }
        }
    };
    const moveLeft = () => {
        if (index !== 0) {
            setIndex((prev) => prev - 1);
        }
        else {
            if (isLoop) {
                setIndex(images.length - 1);
            }
        }
    };
    const handleMouseDown = (e) => {
        e.preventDefault();
        setIsDragging(true);
        setMouseStartX(e.clientX);
    };
    const handleMouseMove = (e) => {
        e.preventDefault();
        if (!isDragging)
            return;
        setCalculatedX(e.clientX - mouseStartX);
    };
    const handleMouseUp = (e) => {
        e.preventDefault();
        if (calculatedX !== 0) {
            if (calculatedX > 200) {
                moveLeft();
            }
            if (calculatedX < -200) {
                moveRight();
            }
        }
        resetState();
    };
    const resetState = () => {
        setCalculatedX(0);
        setMouseStartX(0);
        setIsDragging(false);
    };
    return (_jsxs("div", { children: [_jsx("div", { style: {
                    width: containerWidth,
                    height: 'auto',
                    overflow: 'hidden',
                }, children: _jsx("div", { style: {
                        display: 'flex',
                        width: `${images.length * 100}%`,
                        height: '100%',
                        transition: 'transform 0.5s',
                        transform: typeof containerWidth === 'number'
                            ? `translateX(-${index * containerWidth + calculatedX}px)`
                            : `translateX(-${index * 100}vw) translateX(${isDragging ? calculatedX : 0}px)`,
                    }, children: images.map((item, i) => (_jsx(Image, { onMouseDown: handleMouseDown, onMouseMove: handleMouseMove, onMouseUp: handleMouseUp, alt: `${item.uri}`, src: item.uri, 
                        // priority={true}
                        style: {
                            cursor: isDragging ? 'grabbing' : 'grab',
                            maxWidth: 1200,
                            minWidth: 368,
                            width: calcWidth,
                            height: 'auto',
                            objectFit: 'cover',
                            margin: '0 auto',
                        } }, i))) }) }), _jsxs("div", { style: {
                    display: 'flex',
                    justifyContent: 'space-between',
                    width: '100%',
                    position: 'absolute',
                    zIndex: 31,
                    top: '50%',
                    transform: 'translateY(-50%)',
                    padding: calcWidth > 768 ? '0 2rem' : '',
                }, children: [_jsx("button", { onClick: moveLeft, style: {
                            cursor: 'pointer',
                            padding: '1.5rem 2rem',
                            backgroundColor: 'rgba(255, 255, 255, 0.5)',
                        }, children: _jsx("h2", { style: { color: '#8f8f8f' }, children: "<" }) }), _jsx("button", { onClick: moveRight, style: {
                            cursor: 'pointer',
                            padding: '1.5rem 2rem',
                            backgroundColor: 'rgba(255, 255, 255, 0.5)',
                        }, children: _jsx("h2", { style: { color: '#8f8f8f' }, children: ">" }) })] })] }));
}
//# sourceMappingURL=imageSlide.js.map