import { jsx as _jsx } from "react/jsx-runtime";
import { useEffect, useState } from "react";
import { ModalPortal } from "./portal";
export const Modal = ({ visible = true, onRequestClose, children }) => {
    const [prevVisible, setPrevVisible] = useState(visible);
    useEffect(() => {
        if (prevVisible && !visible) {
            onRequestClose === null || onRequestClose === void 0 ? void 0 : onRequestClose();
        }
        setPrevVisible(visible);
    }, [visible]);
    return (_jsx(ModalPortal, { children: visible ? children : null }));
};
//# sourceMappingURL=modal.js.map